//
//  Aufgabe.swift
//  Aufgabenliste
//
//  Created by Holger Hinzberg on 06.11.17.
//  Copyright © 2017 Holger Hinzberg. All rights reserved.
//

import Foundation

public enum Dringlichkeit : Int { case Unwichtig , Wichtig, SehrWichtig}

public class Aufgabe : NSObject, NSCoding
{
    var Titel:String = ""
    var Beschreibung = ""
    var Prioritaet = Dringlichkeit.Unwichtig
    
    public func encode(with aCoder: NSCoder)
    {
        // Die Eigenschaften für eine Serialisierung umwandeln
        aCoder.encode(self.Titel, forKey: "Titel")
        aCoder.encode(self.Beschreibung, forKey: "Beschreibung")
        // Die Prioritaet wird mit rawValue als Int gespeichert
        let rawValue:Int = self.Prioritaet.rawValue
        aCoder.encode(rawValue , forKey: "Prioritaet")
    }
    
    public required init?(coder aDecoder: NSCoder)
    {
        // Die gesicherten Daten wieder in ein Objekt
        // mit den korrekten Eigenschaften umwandeln
        self.Titel = aDecoder.decodeObject(forKey: "Titel") as! String
        self.Beschreibung = aDecoder.decodeObject(forKey: "Beschreibung") as! String
        // Aus dem Integer wird wieder ein Wert aus der Enumeration
        let intWert : Int = aDecoder.decodeInteger(forKey: "Prioritaet")
       self.Prioritaet =  Dringlichkeit(rawValue: intWert)!
    }
    
    override public init()
    {
    }
}
