//
//  Aufgabenablage.swift
//  Aufgabenliste
//
//  Created by Holger Hinzberg on 06.11.17.
//  Copyright © 2017 Holger Hinzberg. All rights reserved.
//

import Foundation

public class Aufgabenablage
{
    private var aufgaben : [Aufgabe]
    
    init()
    {
        self.aufgaben = [Aufgabe]()
        
        // Überprüfen, ob es eine Datei mit gespeicherten
        // Aufgaben gibt
        let dateiname = self.dateiname()
        let existiert = FileManager.default.fileExists(atPath: dateiname)
        if  existiert == true
        {
            print("Datei gefunden")
            self.laden()
        }
        else
        {
            print("Keine Datei gefunden")
            self.erzeugeBeispiele()
        }
    }
    
    
    func dokumentenVerzeichnis() -> String
    {
        let pfade = NSSearchPathForDirectoriesInDomains(.documentDirectory, .userDomainMask, true)
        let verzeichnis = pfade[0] as String
        print(verzeichnis)
        return verzeichnis
    }
 
    func dateiname() -> String
    {
        let verzeichnis = self.dokumentenVerzeichnis();
        let dateiname = verzeichnis.appending("/aufgaben.txt")
        return dateiname
    }
    
    func laden()
    {
        // Das Array aus der Datei laden
        let dateiname = self.dateiname()
        self.aufgaben = NSKeyedUnarchiver.unarchiveObject(withFile: dateiname) as! [Aufgabe]
    }
    
    func speichern()
    {
        // Das Array unter dem angegebenen
        // Datennamen archivieren
        let dateiname = self.dateiname()
        let warErfolgreich = NSKeyedArchiver.archiveRootObject(self.aufgaben, toFile: dateiname)
        
        if warErfolgreich == true
        {
            print("Speichern erfolgreich")
        }
        else
        {
            print("Speichern nicht erfolgreich")
        }
    }
    
    private func erzeugeBeispiele()
    {
        var aufgabe = Aufgabe()
        aufgabe.Titel = "Hausaufgaben"
        aufgabe.Beschreibung = "Erledige alle Hausaufgaben für die Schule"
        aufgabe.Prioritaet = Dringlichkeit.SehrWichtig
        self.aufgaben.append(aufgabe)
        
        aufgabe = Aufgabe()
        aufgabe.Titel = "Gartenarbeit"
        aufgabe.Beschreibung = "Den Rasen mähen wenn es nicht regnet"
        aufgabe.Prioritaet = Dringlichkeit.Unwichtig
        self.aufgaben.append(aufgabe)
        
        aufgabe = Aufgabe()
        aufgabe.Titel = "Einkaufen"
        aufgabe.Beschreibung = "Brot, Butter, Wurst und Käse"
        aufgabe.Prioritaet = Dringlichkeit.Wichtig
        self.aufgaben.append(aufgabe)
        
        aufgabe = Aufgabe()
        aufgabe.Titel = "Oma anrufen"
        aufgabe.Beschreibung = "Am besten am Sontag"
        aufgabe.Prioritaet = Dringlichkeit.Wichtig
        self.aufgaben.append(aufgabe)
        
        aufgabe = Aufgabe()
        aufgabe.Titel = "Einladung zum Geburtstag"
        aufgabe.Beschreibung = "Geschenke kaufen nicht vergessen"
        aufgabe.Prioritaet = Dringlichkeit.SehrWichtig
        self.aufgaben.append(aufgabe)
    }
    
    // Methode, um eine neue Aufgabe hinzuzufügen
    func hinzufügen(aufgabe:Aufgabe)
    {
        self.aufgaben.append(aufgabe)
    }
    
    // Methode, um eine Aufgabe aus der Liste zu entfernen
    func entfernen(aufgabe:Aufgabe)
    {
        // Die Position der Aufgabe in dem Array finden
        let index = self.aufgaben.index{$0 === aufgabe}
        if index != nil
        {
            // Die Aufgabe aus dem Array entfernen
           self.aufgaben.remove(at: index!)
        }
    }
    
    func entfernen(position:Int)
    {
        let aufgabe = self.aufgabeAn(position: position)
        if let aufgabe = aufgabe
        {
            self.entfernen(aufgabe: aufgabe)
        }
    }
    
    // Die Methode liefert die aktuelle Anzahl der Aufgaben
    func anzahlDerAufgaben() -> Int
    {
        return self.aufgaben.count
    }
    
    // Methode die eine Aufgabe an der gewünschten
    // Position zurückgibt. Kann nil sein, wenn die
    // Position ungültig ist
    func aufgabeAn(position:Int) -> Aufgabe?
    {
        // Die Position muss größer als 0 sein
        guard position >= 0 else
        {
            return nil
        }
        
        // Muss immer kleine sein als die Anzahl der Elememte.
        // Ist die Anzahl 1, ist die kleinst mögliche Position 0
        guard position < self.aufgaben.count else
        {
            return nil
        }
        
        return self.aufgaben[position]
    }
}
